com.smartgwt.client.widgets.tile

## Class TileLayout

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.tile.TileLayout

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers
  Direct Known Subclasses:
    FlowLayout, TileGrid

      public class TileLayout
      extends Canvas

  Lays out a series of components, calls "tiles", in a grid with multiple tiles per row.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TileLayout()`
    `TileLayout(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addTile(Canvas tile)` Add a tile to the layout, dynamically.
    `void` | `addTile(Canvas tile, java.lang.Integer index)` Add a tile to the layout, dynamically.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getAnimateTileChange()` If set, tiles animate to their new positions when a tile is added, removed, or reordered via drag and drop.
    `java.lang.Boolean` | `getAutoWrapLines()` When `LayoutPolicy` is "flow", should we automatically start a new line when there's not enough room to fit the next tile on the same line?
    `DragDataAction` | `getDragDataAction()` Indicates what to do with data dragged into another DataBoundComponent.
    `Canvas` | `getDragLine()` Canvas used to display a drop indicator when a another canvas is dragged over this widget.
    `java.lang.Boolean` | `getExpandMargins()` With `LayoutPolicy`:"fit", should margins be expanded so that tiles fill the available space in the TileLayout on the breadth axis? This can also affect `tileWidth` or `tileHeight`.
    `java.lang.Integer` | `getLayoutMargin()` A margin left around the outside of all tiles.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `static TileLayout` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `Orientation` | `getOrientation()` Direction of tiling.
    `Overflow` | `getOverflow()` Normal `Overflow` settings can be used on TileLayouts, for example, an overflow:auto TileLayout will scroll if members exceed its specified size, whereas an overflow:visible TileLayout will grow to accommodate members.
    `java.lang.Boolean` | `getPaddingAsLayoutMargin()` If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?
    `Canvas` | `getTile(int index)` Retrieve a tile by index.
    `java.lang.Integer` | `getTileHeight()` Height of each tile in pixels.
    `java.lang.Integer` | `getTileHMargin()` Horizontal margin in between tiles.
    `int` | `getTileMargin()` Margin in between tiles.
    `int` | `getTileSize()` Size of each tile in pixels.
    `java.lang.Integer` | `getTilesPerLine()` Number of tiles to show in each line.
    `java.lang.Integer` | `getTileVMargin()` Vertical margin in between tiles.
    `java.lang.Integer` | `getTileWidth()` Width of each tile in pixels.
    `void` | `layoutTiles()` Forces layout out the tiles
    `boolean` | `removeTile(Canvas tile)` Remove a tile from the layout.
    `boolean` | `removeTile(int tileIndex)` Remove a tile from the layout.
    `boolean` | `removeTile(java.lang.String tileID)` Remove a tile from the layout.
    `void` | `setAnimateTileChange(java.lang.Boolean animateTileChange)` If set, tiles animate to their new positions when a tile is added, removed, or reordered via drag and drop.
    `void` | `setAutoWrapLines(java.lang.Boolean autoWrapLines)` When `LayoutPolicy` is "flow", should we automatically start a new line when there's not enough room to fit the next tile on the same line?
    `static void` | `setDefaultProperties(TileLayout tileLayoutProperties)` Class level method to set the default properties of this class.
    `void` | `setDragDataAction(DragDataAction dragDataAction)` Indicates what to do with data dragged into another DataBoundComponent.
    `void` | `setExpandMargins(java.lang.Boolean expandMargins)` With `LayoutPolicy`:"fit", should margins be expanded so that tiles fill the available space in the TileLayout on the breadth axis? This can also affect `tileWidth` or `tileHeight`.
    `void` | `setLayoutMargin(java.lang.Integer layoutMargin)` A margin left around the outside of all tiles.
    `void` | `setLayoutPolicy(TileLayoutPolicy layoutPolicy)` Policy for laying out tiles.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.tile.TileLayoutLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setOrientation(Orientation orientation)` Direction of tiling.
    `void` | `setOverflow(Overflow overflow)` Normal `Overflow` settings can be used on TileLayouts, for example, an overflow:auto TileLayout will scroll if members exceed its specified size, whereas an overflow:visible TileLayout will grow to accommodate members.
    `void` | `setPaddingAsLayoutMargin(java.lang.Boolean paddingAsLayoutMargin)` If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?
    `void` | `setTileHeight(java.lang.Integer tileHeight)` Height of each tile in pixels.
    `void` | `setTileHMargin(java.lang.Integer tileHMargin)` Horizontal margin in between tiles.
    `void` | `setTileMargin(int tileMargin)` Margin in between tiles.
    `void` | `setTiles(Canvas... tiles)` List of tiles to lay out.
    `void` | `setTileSize(int tileSize)` Size of each tile in pixels.
    `void` | `setTilesPerLine(java.lang.Integer tilesPerLine)` Number of tiles to show in each line.
    `void` | `setTileVMargin(java.lang.Integer tileVMargin)` Vertical margin in between tiles.
    `void` | `setTileWidth(java.lang.Integer tileWidth)` Width of each tile in pixels.

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getEditProxyConstructor, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAlign, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setEditProxyConstructor, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### TileLayout

          public TileLayout()

    - #### TileLayout

          public TileLayout(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static TileLayout getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Canvas`

    - #### setAnimateTileChange

          public void setAnimateTileChange(java.lang.Boolean animateTileChange)

      If set, tiles animate to their new positions when a tile is added, removed, or reordered via drag and drop.

      Note : This is an advanced setting

      Parameters:
        `animateTileChange` - Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getAnimateTileChange

          public java.lang.Boolean getAnimateTileChange()

      If set, tiles animate to their new positions when a tile is added, removed, or reordered via drag and drop.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setAutoWrapLines

          public void setAutoWrapLines(java.lang.Boolean autoWrapLines)
                                throws java.lang.IllegalStateException

      When `LayoutPolicy` is "flow", should we automatically start a new line when there's not enough room to fit the next tile on the same line?

      If set to false, a new line will only be started if a tile specifies tile.startLine or tile.endLine.

      Parameters:
        `autoWrapLines` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getAutoWrapLines

          public java.lang.Boolean getAutoWrapLines()

      When `LayoutPolicy` is "flow", should we automatically start a new line when there's not enough room to fit the next tile on the same line?

      If set to false, a new line will only be started if a tile specifies tile.startLine or tile.endLine.

      Returns:
        Boolean

    - #### setDragDataAction

          public void setDragDataAction(DragDataAction dragDataAction)

      Indicates what to do with data dragged into another DataBoundComponent. See DragDataAction type for details.
      Parameters:
        `dragDataAction` - Default value is Canvas.MOVE
      See Also:
        Drag move Example, Drag copy Example

    - #### getDragDataAction

          public DragDataAction getDragDataAction()

      Indicates what to do with data dragged into another DataBoundComponent. See DragDataAction type for details.
      Returns:
        DragDataAction
      See Also:
        Drag move Example, Drag copy Example

    - #### getDragLine

          public Canvas getDragLine()
                             throws java.lang.IllegalStateException

      Canvas used to display a drop indicator when a another canvas is dragged over this widget.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setExpandMargins

          public void setExpandMargins(java.lang.Boolean expandMargins)
                                throws java.lang.IllegalStateException

      With `LayoutPolicy`:"fit", should margins be expanded so that tiles fill the available space in the TileLayout on the breadth axis? This can also affect `tileWidth` or `tileHeight`. See those properties for details.
      Parameters:
        `expandMargins` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExpandMargins

          public java.lang.Boolean getExpandMargins()

      With `LayoutPolicy`:"fit", should margins be expanded so that tiles fill the available space in the TileLayout on the breadth axis? This can also affect `tileWidth` or `tileHeight`. See those properties for details.
      Returns:
        Boolean

    - #### setLayoutMargin

          public void setLayoutMargin(java.lang.Integer layoutMargin)
                               throws java.lang.IllegalStateException

      A margin left around the outside of all tiles.
      Parameters:
        `layoutMargin` - Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLayoutMargin

          public java.lang.Integer getLayoutMargin()

      A margin left around the outside of all tiles.
      Returns:
        Integer

    - #### setOrientation

          public void setOrientation(Orientation orientation)
                              throws java.lang.IllegalStateException

      Direction of tiling. See also `TileLayoutPolicy`.
      Parameters:
        `orientation` - Default value is "horizontal"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOrientation

          public Orientation getOrientation()

      Direction of tiling. See also `TileLayoutPolicy`.
      Returns:
        Orientation

    - #### setOverflow

          public void setOverflow(Overflow overflow)

      Normal `Overflow` settings can be used on TileLayouts, for example, an overflow:auto TileLayout will scroll if members exceed its specified size, whereas an overflow:visible TileLayout will grow to accommodate members.
      Overrides:
        `setOverflow` in class `Canvas`
      Parameters:
        `overflow` - Default value is "auto"
      See Also:
        `Sizing overview and related methods`

    - #### getOverflow

          public Overflow getOverflow()

      Normal `Overflow` settings can be used on TileLayouts, for example, an overflow:auto TileLayout will scroll if members exceed its specified size, whereas an overflow:visible TileLayout will grow to accommodate members.
      Overrides:
        `getOverflow` in class `Canvas`
      Returns:
        Overflow
      See Also:
        `Sizing overview and related methods`

    - #### setPaddingAsLayoutMargin

          public void setPaddingAsLayoutMargin(java.lang.Boolean paddingAsLayoutMargin)

      If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?

      If this setting is false, padding will not affect member positioning (as CSS padding normally does not affect absolutely positioned children). Leaving this setting true allows a designer to more effectively control layout purely from CSS.

      Note that `Layout.layoutMargin` if specified, takes precedence over this value.

      Note : This is an advanced setting

      Parameters:
        `paddingAsLayoutMargin` - Default value is true

    - #### getPaddingAsLayoutMargin

          public java.lang.Boolean getPaddingAsLayoutMargin()

      If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?

      If this setting is false, padding will not affect member positioning (as CSS padding normally does not affect absolutely positioned children). Leaving this setting true allows a designer to more effectively control layout purely from CSS.

      Note that `Layout.layoutMargin` if specified, takes precedence over this value.

      Returns:
        Boolean

    - #### setTileHeight

          public void setTileHeight(java.lang.Integer tileHeight)
                             throws java.lang.IllegalStateException

      Height of each tile in pixels. See `tileSize`. If `LayoutPolicy` is "fit", `expandMargins` is false, `tilesPerLine` is set, `Orientation` is "vertical", and tileHeight is not set, tileHeight will be computed automatically based on `tilesPerLine`.
      If this method is called after the component has been drawn/initialized: Sets the height of tiles.
      Parameters:
        `tileHeight` - height. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Sizing overview and related methods`

    - #### getTileHeight

          public java.lang.Integer getTileHeight()

      Height of each tile in pixels. See `tileSize`. If `LayoutPolicy` is "fit", `expandMargins` is false, `tilesPerLine` is set, `Orientation` is "vertical", and tileHeight is not set, tileHeight will be computed automatically based on `tilesPerLine`.
      Returns:
        Integer
      See Also:
        `Sizing overview and related methods`

    - #### setTileHMargin

          public void setTileHMargin(java.lang.Integer tileHMargin)
                              throws java.lang.IllegalStateException

      Horizontal margin in between tiles. See `tileMargin`.
      If this method is called after the component has been drawn/initialized: Sets the horizontal margin of tiles.
      Parameters:
        `tileHMargin` - width. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTileHMargin

          public java.lang.Integer getTileHMargin()

      Horizontal margin in between tiles. See `tileMargin`.
      Returns:
        Integer

    - #### setTileMargin

          public void setTileMargin(int tileMargin)
                             throws java.lang.IllegalStateException

      Margin in between tiles. Can be set on a per-axis basis with `tileHMargin` and `tileVMargin`.
      If this method is called after the component has been drawn/initialized: Sets the vertical and horizontal margin of tiles.
      Parameters:
        `tileMargin` - margin. Default value is 10
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTileMargin

          public int getTileMargin()

      Margin in between tiles. Can be set on a per-axis basis with `tileHMargin` and `tileVMargin`.
      Returns:
        int

    - #### setTiles

          public void setTiles(Canvas... tiles)
                        throws java.lang.IllegalStateException

      List of tiles to lay out.
      Parameters:
        `tiles` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setTileSize

          public void setTileSize(int tileSize)
                           throws java.lang.IllegalStateException

      Size of each tile in pixels. Depending on the `LayoutPolicy`, `tileSize` may be taken as a maximum, minimum or exact size of tiles, or may be irrelevant.

      Width and height may be separately set via `tileHeight` and `tileWidth`.
      If this method is called after the component has been drawn/initialized: Sets the height and width of tiles.

      Parameters:
        `tileSize` - size. Default value is 50
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Sizing overview and related methods`

    - #### getTileSize

          public int getTileSize()

      Size of each tile in pixels. Depending on the `LayoutPolicy`, `tileSize` may be taken as a maximum, minimum or exact size of tiles, or may be irrelevant.

      Width and height may be separately set via `tileHeight` and `tileWidth`.

      Returns:
        int
      See Also:
        `Sizing overview and related methods`

    - #### setTilesPerLine

          public void setTilesPerLine(java.lang.Integer tilesPerLine)

      Number of tiles to show in each line. Auto-derived from `tileSize` for some layout modes. See `TileLayoutPolicy`. This can also affect `tileWidth` or `tileHeight`. See those properties for details.
      If this method is called after the component has been drawn/initialized: Sets the number of tiles per line.
      Parameters:
        `tilesPerLine` - New `tilesPerLine` value. Default value is null

    - #### getTilesPerLine

          public java.lang.Integer getTilesPerLine()

      Number of tiles to show in each line. Auto-derived from `tileSize` for some layout modes. See `TileLayoutPolicy`. This can also affect `tileWidth` or `tileHeight`. See those properties for details.
      Returns:
        Integer

    - #### setTileVMargin

          public void setTileVMargin(java.lang.Integer tileVMargin)
                              throws java.lang.IllegalStateException

      Vertical margin in between tiles. See `tileMargin`.
      If this method is called after the component has been drawn/initialized: Sets the vertical margin of tiles.
      Parameters:
        `tileVMargin` - width. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTileVMargin

          public java.lang.Integer getTileVMargin()

      Vertical margin in between tiles. See `tileMargin`.
      Returns:
        Integer

    - #### setTileWidth

          public void setTileWidth(java.lang.Integer tileWidth)
                            throws java.lang.IllegalStateException

      Width of each tile in pixels. See `tileSize`. If `LayoutPolicy` is "fit", `expandMargins` is false, `tilesPerLine` is set, `Orientation` is "horizontal", and tileWidth is not set, tileWidth will be computed automatically based on `tilesPerLine`.
      If this method is called after the component has been drawn/initialized: Sets the width of tiles.
      Parameters:
        `tileWidth` - width. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Sizing overview and related methods`

    - #### getTileWidth

          public java.lang.Integer getTileWidth()

      Width of each tile in pixels. See `tileSize`. If `LayoutPolicy` is "fit", `expandMargins` is false, `tilesPerLine` is set, `Orientation` is "horizontal", and tileWidth is not set, tileWidth will be computed automatically based on `tilesPerLine`.
      Returns:
        Integer
      See Also:
        `Sizing overview and related methods`

    - #### addTile

          public void addTile(Canvas tile)

      Add a tile to the layout, dynamically.
      Parameters:
        `tile` - new tile to add

    - #### addTile

          public void addTile(Canvas tile,
                              java.lang.Integer index)

      Add a tile to the layout, dynamically.
      Parameters:
        `tile` - new tile to add
        `index` - position where the tile should be added. Defaults to adding the tile at the end.

    - #### getTile

          public Canvas getTile(int index)

      Retrieve a tile by index.

      The TileLayout consistently uses this method to access tiles, in order to allow subclasses to create tiles on demand.

      Parameters:
        `index` - index of the tile
      Returns:
        the tile

    - #### setDefaultProperties

          public static void setDefaultProperties(TileLayout tileLayoutProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `tileLayoutProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setLayoutPolicy

          public void setLayoutPolicy(TileLayoutPolicy layoutPolicy)
                               throws java.lang.IllegalStateException

      Policy for laying out tiles. See `TileLayoutPolicy` for options.
      Parameters:
        `layoutPolicy` - layoutPolicy Default value is ""
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### removeTile

          public boolean removeTile(int tileIndex)

      Remove a tile from the layout.
      Parameters:
        `tileIndex` - index or String ID of the tile
      Returns:
        whether a tile was found and removed

    - #### removeTile

          public boolean removeTile(java.lang.String tileID)

      Remove a tile from the layout.
      Parameters:
        `tileID` - index or String ID of the tile
      Returns:
        whether a tile was found and removed

    - #### removeTile

          public boolean removeTile(Canvas tile)

      Remove a tile from the layout.
      Parameters:
        `tile` - index or String ID of the tile
      Returns:
        whether a tile was found and removed

    - #### layoutTiles

          public void layoutTiles()

      Forces layout out the tiles

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.tile.TileLayoutLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Canvas`